/**
 * 
 */
package ch.ivyteam.ivy.process.eventstart.beans;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.swing.JLabel;

import ch.ivyteam.ivy.process.eventstart.AbstractProcessStartEventBean;
import ch.ivyteam.ivy.process.extension.IIvyScriptEditor;
import ch.ivyteam.ivy.process.extension.IProcessExtensionConfigurationEditorEnvironment;
import ch.ivyteam.ivy.process.extension.impl.AbstractProcessExtensionConfigurationEditor;
import ch.ivyteam.ivy.request.RequestException;
import ch.ivyteam.util.PropertiesUtil;

public class DailyMailSenderBean extends AbstractProcessStartEventBean {

	private static final String TIME = "time";

	public DailyMailSenderBean() {
		super("DailyMailSenderBean", "Description of DailyMailSenderBean");
	}

	/* (non-Javadoc)
	 * @see ch.ivyteam.ivy.process.eventstart.IProcessStartEventBean#poll()
	 */
	@Override
	public void poll() {
		String firingReason = "";
		Map<String, Object> parameters = new HashMap<String, Object>();

		Calendar sendTime = getSendTime();
		Calendar now = Calendar.getInstance();
		
		if (now.after(sendTime)) {
			try {
				getEventBeanRuntime().fireProcessStartEventRequest(null, firingReason, parameters);
			} catch (RequestException ex) {
				// ===> Add here your exception handling code if the event cannot be processed <===
			}
		}
	}

	private Calendar getSendTime() {
		Properties config = PropertiesUtil.createProperties(getConfiguration());
		String time = config.getProperty(TIME, "");
		String[] parts = time.split(":");
		int hours = Integer.valueOf(parts[0]);
		int minutes = Integer.valueOf(parts[1]);
		
		Calendar sendTime = Calendar.getInstance();
		sendTime.set(Calendar.HOUR_OF_DAY, hours);
		sendTime.set(Calendar.MINUTE, minutes);
		return sendTime;
	}

	public static class Editor extends AbstractProcessExtensionConfigurationEditor {

		private IIvyScriptEditor demoIvyScriptField;

		/* (non-Javadoc)
		 * @see ch.ivyteam.ivy.process.extension.impl.AbstractProcessExtensionConfigurationEditor#createEditorPanelContent(java.awt.Container, ch.ivyteam.ivy.process.extension.IProcessExtensionConfigurationEditorEnvironment)
		 */
		@Override
		protected void createEditorPanelContent(
				Container editorPanel,
				IProcessExtensionConfigurationEditorEnvironment editorEnvironment) {

			// ===> Add here your code to create new ui widgets and to add them to the editor panel here <===
			// You can use the editorEnvironment to create TextField that are ivyScript aware.

			
			editorPanel.add(new JLabel("Time"),
					new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.NORTHWEST,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
			demoIvyScriptField = editorEnvironment.createIvyScriptEditor();
			
			editorPanel.add(demoIvyScriptField.getComponent(),
					new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,
							GridBagConstraints.NORTHWEST,
							GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0,
									0), 0, 0));
		}

		/* (non-Javadoc)
		 * @see ch.ivyteam.ivy.process.extension.impl.AbstractProcessExtensionConfigurationEditor#loadUiDataFromConfiguration()
		 */
		@Override
		protected void loadUiDataFromConfiguration() {

			// ===> Add here your code to load data from the configuration to the ui widgets <===
			// You can use the getBeanConfiguration() or getBeanConfigurationProperty() methods to load the configuration

			demoIvyScriptField.setText(getBeanConfigurationProperty(TIME));
		}

		/* (non-Javadoc)
		 * @see ch.ivyteam.ivy.process.extension.impl.AbstractProcessExtensionConfigurationEditor#saveUiDataToConfiguration()
		 */
		@Override
		protected boolean saveUiDataToConfiguration() {

			// Clear the bean configuration and all its properties to flush outdated configurations.
			clearBeanConfiguration();

			// ===> Add here your code to save the data in the ui widgets to the configuration <===
			// You can use the setBeanConfiguration() or setBeanConfigurationProperty() methods to save the configuration

			setBeanConfigurationProperty(TIME, demoIvyScriptField.getText());
			return true;
		}
	}

}
